//  outport.c - Write data to a Z80 I/O port

#include <ioport.h>

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

void outport (unsigned int addr, unsigned int data) __naked
    {
    addr; data;
    __asm
#if __SDCCCALL == 1
        ld      c, l        ; Copy address
        ld      b, h
#else
        ld      hl, #2      ; Start of parameters
        add     hl, sp
        ld      c, (hl)     ; Low byte of address
        inc     hl          ; High byte of address
        ld      b, (hl)
        inc     hl          ; Low byte of the data
        ld      e, (hl)
#endif
        out     (c), e      ; Write data to the port
        ret
    __endasm;
    }
